#ifndef INIT_H
#define INIT_H

#include <l4/sys/compiler.h>
#include <l4/util/mb_info.h>

#include "exec.h"

#define INIT_SECTION __attribute__((section (".init")))

void init(void) L4_NORETURN;

/* the following variables may only by used during boot -- their
   storage is freed after initialization in init.c */

extern int boot_errors, boot_wait, l4_version;

l4util_mb_mod_t mb_mod[MODS_MAX];
l4util_mb_vbe_ctrl_t mb_vbe_ctrl;
l4util_mb_vbe_mode_t mb_vbe_mode;

#define VERSION_L4_V2	  0
#define VERSION_L4_IBM    1
#define VERSION_FIASCO    2
#define VERSION_L4_KA     3

#define KERNEL_NAMES ((char*[4]) { "L4/GMD", "LN/IBM", "Fiasco", \
				   "L4Ka::Hazelnut" })

extern vm_offset_t mod_range_start, mod_range_end;

void mod_exec_init(l4util_mb_mod_t *mod,
		   unsigned mod_first, unsigned mod_count);

exec_read_func_t mod_exec_read;
exec_read_exec_func_t mod_exec_read_exec;

void boot_error(void);

#endif

